<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Class: graph</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Class: graph</h1>

    




<section>

<header>
    
        <h2><span class="attribs"><span class="type-signature"></span></span>
            <span class="ancestors"><a href="MTLG.html">MTLG</a><a href="MTLG.utilities.html">.utilities</a>.</span>graph<span class="signature">()</span><span class="type-signature"></span></h2>
        
    
</header>

<article>
    <div class="container-overview">
    
        

    

    
    <h4 class="name" id="graph"><span class="type-signature"></span>new graph<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    basic graph structure
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line24">line 24</a>
    </li></ul></dd>
    

    

    

    
</dl>


















    
    </div>

    

    

    

    

    

    

    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id="..addEdge"><span class="type-signature">(static) </span>.addEdge<span class="signature">(node1, node2)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Adds an edge to the graph
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>node1</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">Start node.</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>node2</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">End node.</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line190">line 190</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..addEdges"><span class="type-signature">(static) </span>.addEdges<span class="signature">(edges)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Adds edges to the graph.
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>edges</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">An array of edges [[n0,n1][n1,n2],...].</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line259">line 259</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..addNode"><span class="type-signature">(static) </span>.addNode<span class="signature">(value)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Adds a node to the graph
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">Set the value of the node.</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line38">line 38</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..addNodes"><span class="type-signature">(static) </span>.addNodes<span class="signature">(values)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Adds for each value in the values array a node to the graph
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>values</code></td>
            

            <td class="type">
            
                
<span class="param-type">array</span>


            
            </td>

            

            

            <td class="description last">Array of values representing nodes.</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line147">line 147</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..addToStage"><span class="type-signature">(static) </span>.addToStage<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Adds the graph to the stage.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line459">line 459</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..distributeOnStage"><span class="type-signature">(static) </span>.distributeOnStage<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Distribute the nodes on the screen (alpha version).<br>
TODO implement a beta version
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line551">line 551</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..getFirstEdge"><span class="type-signature">(static) </span>.getFirstEdge<span class="signature">()</span><span class="type-signature"> &rarr; {type}</span></h4>
    

    



<div class="description">
    Returns the first edge, if it exists. Or false, if not.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line333">line 333</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    The first edge or false.
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">type</span>


    </dd>
</dl>

    





        
            

    

    
    <h4 class="name" id="..getFirstNode"><span class="type-signature">(static) </span>.getFirstNode<span class="signature">()</span><span class="type-signature"> &rarr; {type}</span></h4>
    

    



<div class="description">
    Returns the first node, if it exists. Or false, if not.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line305">line 305</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    The first node or false.
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">type</span>


    </dd>
</dl>

    





        
            

    

    
    <h4 class="name" id="..getLastEdge"><span class="type-signature">(static) </span>.getLastEdge<span class="signature">()</span><span class="type-signature"> &rarr; {type}</span></h4>
    

    



<div class="description">
    Returns the last edge, if it exists. Or false, if not.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line347">line 347</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    The last edge or false.
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">type</span>


    </dd>
</dl>

    





        
            

    

    
    <h4 class="name" id="..getLastNode"><span class="type-signature">(static) </span>.getLastNode<span class="signature">()</span><span class="type-signature"> &rarr; {type}</span></h4>
    

    



<div class="description">
    Returns the last node, if it exists. Or false, if not.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line319">line 319</a>
    </li></ul></dd>
    

    

    

    
</dl>













<h5>Returns:</h5>

        
<div class="param-desc">
    The last node or false.
</div>



<dl>
    <dt>
        Type
    </dt>
    <dd>
        
<span class="param-type">type</span>


    </dd>
</dl>

    





        
            

    

    
    <h4 class="name" id="..randomEdges"><span class="type-signature">(static) </span>.randomEdges<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Adds edges to nodes randomly (80 % )
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line524">line 524</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..rmEdges"><span class="type-signature">(static) </span>.rmEdges<span class="signature">(edge)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Removes an edge of the graph.
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>edge</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">Edge to remove.</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line288">line 288</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..rmGraph"><span class="type-signature">(static) </span>.rmGraph<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Removes the graph.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line489">line 489</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..rmNode"><span class="type-signature">(static) </span>.rmNode<span class="signature">(node)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Deletes a node of the graph
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>node</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">Removes the node out of the graph.</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line172">line 172</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..setAllEdgesProperties"><span class="type-signature">(static) </span>.setAllEdgesProperties<span class="signature">(p, value, graphics)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Updates a general property or a graphics property of all edges with a specific value.
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>p</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">Property to update.</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">Value to set to property.</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>graphics</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">false for general property | true for graphics property.</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line398">line 398</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..setAllNodesProperties"><span class="type-signature">(static) </span>.setAllNodesProperties<span class="signature">(p, value, graphics)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Updates a general property or a graphics property of all nodes with a specific value.
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>p</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">Property to update.</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>value</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">Value to set to property.</td>
        </tr>

    

        <tr>
            
                <td class="name"><code>graphics</code></td>
            

            <td class="type">
            
                
<span class="param-type">type</span>


            
            </td>

            

            

            <td class="description last">false for general property | true for graphics property.</td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line373">line 373</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..setGraphicsEdges"><span class="type-signature">(static) </span>.setGraphicsEdges<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Set the graphics of each edge.<br>
TODO set graphics with a function and standard strike as fallback.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line445">line 445</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..setGraphicsNodes"><span class="type-signature">(static) </span>.setGraphicsNodes<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Set the graphics of each nodes.<br>
TODO set graphics with a function and circle as fallback.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line423">line 423</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..updateEdges"><span class="type-signature">(static) </span>.updateEdges<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Updates the position of the edges.
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line361">line 361</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="..updateGraph"><span class="type-signature">(static) </span>.updateGraph<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    Updates the graph graphics.<br>
TODO do not add all edges if only one edge is new
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="modules_mtlg-moduls-utilities_utilities.js.html">modules/mtlg-moduls-utilities/utilities.js</a>, <a href="modules_mtlg-moduls-utilities_utilities.js.html#line509">line 509</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
    

    

    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="MTLG.utilities.graph.html">graph</a></li></ul><h3>Namespaces</h3><ul><li><a href="MTLG.html">MTLG</a></li><li><a href="MTLG.menu.html">menu</a></li><li><a href="MTLG.tangible.html">tangible</a></li><li><a href="MTLG.utilities.html">utilities</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Mon Dec 04 2017 15:08:57 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>